-- Rakzul (EU-Sunstrider) told me I own this now, thanks bud!
--RepairGear
RepairGearDB = {
   autoRepair = true,
   useGuildBank = true,
   showMsg = true,
}
local lower = string.lower
-- Print function
local print = function(msg)
   print("|cFF00bfffRepairGear|r: " .. msg)
end
-- Help display function
local function ShowHelp()
	print("/rg repair - Toggle using automatic repair (currently " ..
      (RepairGearDB.autoRepair and "ON" or "OFF") .. ")")
	print("/rg gbank - Toggle using guild bank for repairs (currently " ..
      (RepairGearDB.useGuildBank and "ON" or "OFF") .. ")")
   print("/rg showmsg - Toggle displaying messages when repairing (currently " ..
      (RepairGearDB.showMsg and "ON" or "OFF") .. ")")
end
-- Slash command function
SLASH_REPAIRGEAR1 = "/rg"
SLASH_REPAIRGEAR2 = "/repairgear"
SlashCmdList["REPAIRGEAR"] = function(cmd)
   if ((not cmd) or (cmd == "")) then
      ShowHelp()
      return
   end
   cmd = lower(cmd)
   local args = {}
   for arg in cmd:gmatch("%S+") do
      table.insert(args, arg)
   end
   if (args[1] == "repair") then
      -- Toggle automatic repairs
      RepairGearDB.autoRepair = not RepairGearDB.autoRepair
      print("Automatic repairs: " ..
         (RepairGearDB.autoRepair and "ON" or "OFF"))
   elseif (args[1] == "gbank") then
      -- Toggle using guild bank for repairs
      RepairGearDB.useGuildBank = not RepairGearDB.useGuildBank
      print("Repairing using guild bank funds: " ..
         (RepairGearDB.useGuildBank and "ON" or "OFF"))
   elseif (args[1] == "showmsg") then
      -- Toggle displaying messages
      RepairGearDB.showMsg = not RepairGearDB.showMsg
      print("Displaying messages when repairing: " ..
         (RepairGearDB.showMsg and "ON" or "OFF"))
   else
      ShowHelp()
   end
end
local f = CreateFrame("Frame")
f:RegisterEvent("MERCHANT_SHOW")
f:SetScript("OnEvent", function()
   -- Can the merchant repair items?
   if (not CanMerchantRepair()) then
      return
   end
   -- Repairs disabled (addon off)
   if (not RepairGearDB.autoRepair) then
      return
   end
   local repCost = GetRepairAllCost()
   -- Nothing's damaged
   if (repCost <= 0) then
      return
   end
   local guildRep = nil
   -- Use guild bank funds for repair?
   if (RepairGearDB.useGuildBank and IsInGuild() and CanGuildBankRepair()) then
      local withdrawLimit = GetGuildBankWithdrawMoney()
      local guildBankMoney = GetGuildBankMoney()
      -- Guild leader (unlimited withdrawal privileges)
      if (withdrawLimit == -1) then
         withdrawLimit = guildBankMoney
      else
         withdrawLimit = min(withdrawLimit, guildBankMoney)
      end
      if (repCost < withdrawLimit) then
         guildRep = true
      end
   end
   -- Can't afford to repair
   if ((not guildRep) and (GetMoney() < repCost)) then
      print("You can't afford to repair!")
      return
   end
   if (RepairGearDB.showMsg) then
      print("Repaired" ..
         (guildRep and " from guild bank " or " ") .. "for " ..
         math.floor(repCost / 10000) .. "." ..
         math.floor((repCost % 10000) / 100) .. "g")
   end
   RepairAllItems(guildRep)
   -- Disable repair all icon in merchant
   SetDesaturation(MerchantRepairAllIcon, 1)
   MerchantRepairAllButton:Disable()
   -- Disable guild bank repair all icon in merchant
   SetDesaturation(MerchantGuildBankRepairButtonIcon, 1)
   MerchantGuildBankRepairButton:Disable()
end)